local rect={}
rect.effect = love.graphics.newPixelEffect[[

extern number	time;
//extern vec2 mouse;
extern vec2		screen;
extern vec2		center;
extern vec2		size;
extern number	round;
extern vec3		bg_color;
extern vec3		fg_color;

//round-edged rotated clipping for GLES20 by Matt DesLauriers
//http://devmatt.wordpress.com

vec2 clip_pos  = vec2( center.x - round, screen.y - ( center.y + round ) );
vec2 clip_size = size;		// rectangle dimensions
const number BLUR = 1.0; 	//1.0 leads to a smooth edge

number clip(vec2 p, number rotation)
	{
	number c = cos(-rotation);
	number s = sin(-rotation);
	p -= round;
	vec2 ps = clip_pos;
	vec2 sz = clip_size - 2 * round;

	//rotate rectangle (added sz/2 to center rotation)
	number rx = ps.x + c * (p.x - ps.x) - s * (p.y - ps.y) + sz.x/2;
	number ry = ps.y + s * (p.x - ps.x) + c * (p.y - ps.y) + sz.y/2;

	//determine rectangle
	vec2	v	= abs( vec2( rx, ry ) - ps - sz/2 ) - sz/2 + 0.5;
	number	d	= length( max( v, 0.0 ) );
	return smoothstep( BLUR + round, round, d );
	}

vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
	{
	vec2	position	= pc.xy;
  	number	c			= clip( position, time * 0.25 );
	vec4 pixel		= Texel( tex, tc );
		pixel.r 	= (fg_color.x-bg_color.x)*c+bg_color.x;
		pixel.g 	= (fg_color.y-bg_color.y)*c+bg_color.y;
		pixel.b 	= (fg_color.z-bg_color.z)*c+bg_color.z;
		pixel.a 	= 1;
	return pixel;
	}
]]

return rect
